﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = TreeData.GenerateTreeData();
        }

        private void XamDataTree_InitializeNode(object sender, Infragistics.Controls.Menus.InitializeNodeEventArgs e)
        {
            e.Node.IsExpanded = true;
            if (e.Node.Data is TreeData)
            {
                // IsOnNodeActiveEditingEnabled="True"
                e.Node.IsActive = true;
            }
        }

        private void XamDataTree_NodeEnteringEditMode(object sender, Infragistics.Controls.Menus.BeginEditingNodeEventArgs e)
        {
            if (!(e.Node.Data is TreeData))
            {
                // Keep other objects not in scope from going into edit mode
                e.Cancel = true;
            }
        }

        private void XamDataTree_NodeExitingEditMode(object sender, Infragistics.Controls.Menus.TreeExitEditingEventArgs e)
        {
            // e.EditingCanceled is true? why? This event is called immediately after e.Node.IsActive is set to true in InitializeNode
        }
    }

    public class TreeData
    {
        private int id;

        public int ID
        {
            get { return id; }
            set { id = value; }
        }

        private string name;

        public string Name
        {
            get { return name; }
            set { name = value;  }
        }

        private ObservableCollection<TreeData> children;

        public ObservableCollection<TreeData> Children
        {
            get { return children; }
            set { children = value; }
        }

        public static ObservableCollection<TreeData> GenerateTreeData()
        {
            ObservableCollection<TreeData> data = new ObservableCollection<TreeData>();

            for (int i = 0; i < 10; i++)
            {
                TreeData n = new TreeData
                {
                    ID = i,
                    Name = "Item " + i,
                    Children = new ObservableCollection<TreeData>()
                };

                for (int j = 0; j < 5; j++)
                {
                    TreeData n1 = new TreeData
                    {
                        ID = i + j,
                        Name = "Item " + i + " " + j,
                        Children = new ObservableCollection<TreeData>()
                    };

                    for (int p = 0; p < 5; p++)
                    {
                        n1.children.Add(new TreeData
                        {
                            ID = i + j + p,
                            Name = "Item " + i + " " + j + " " + p,
                        });
                    }

                    n.Children.Add(n1);
                }

                data.Add(n);
            }

            return data;
        }

    }
}
